unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ovVirtualDataSet, ovDataSet, StdCtrls, Grids, DBGrids,
  ExtCtrls, DBCtrls, ComCtrls, Mask;

type
  TfrmMain = class(TForm)
    ContactExposer: TovExposer;
    PersonExposer: TovExposer;
    CompanyExposer: TovExposer;
    EmployeeExposer: TovExposer;
    ContactSource: TDataSource;
    PersonSource: TDataSource;
    CompanySource: TDataSource;
    EmployeeSource: TDataSource;
    Panel1: TPanel;
    DBNavigator: TDBNavigator;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    ContactGrid: TDBGrid;
    TabSheet2: TTabSheet;
    CompanyGrid: TDBGrid;
    Splitter1: TSplitter;
    TabSheet3: TTabSheet;
    PersonGrid: TDBGrid;
    TabSheet4: TTabSheet;
    ContactExposerDSDesigner: TStringField;
    ContactExposerPhones: TStringField;
    PageControl1: TPageControl;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    CompanyPhoneGrid: TDBGrid;
    TabSheet8: TTabSheet;
    CompanyPhoneExposer: TovExposer;
    CompanyPhoneSource: TDataSource;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    Label5: TLabel;
    Label6: TLabel;
    DBEdit7: TDBEdit;
    Label7: TLabel;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    DBGrid1: TDBGrid;
    PageControl2: TPageControl;
    TabSheet9: TTabSheet;
    Splitter2: TSplitter;
    DBGrid2: TDBGrid;
    PersonPhoneExposer: TovExposer;
    PersonPhoneSource: TDataSource;
    QueryGrid: TDBGrid;
    mmQuery: TMemo;
    Panel2: TPanel;
    Splitter3: TSplitter;
    cbQuery: TComboBox;
    QueryBtn: TButton;
    Label9: TLabel;
    QuerySource: TDataSource;
    Query: TovQuery;
    TabSheet10: TTabSheet;
    DBEdit9: TDBEdit;
    DBEdit10: TDBEdit;
    DBEdit11: TDBEdit;
    DBEdit12: TDBEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    PersonExposerDSDesigner: TDateField;
    PersonExposerDSDesigner2: TStringField;
    PersonExposerDSDesigner3: TStringField;
    PersonExposerDSDesigner4: TStringField;
    PersonExposerDSDesigner5: TStringField;
    PersonExposerDSDesigner6: TStringField;
    PersonExposerWorksIn: TIntegerField;
    PersonExposerCompany: TStringField;
    procedure GridEnter(Sender: TObject);
    procedure ContactExposerCalcFields(DataSet: TDataSet);
    procedure QueryBtnClick(Sender: TObject);
    procedure cbQueryChange(Sender: TObject);
    procedure PersonExposerAfterPost(DataSet: TDataSet);
    procedure ContactsRefresh(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses ovTypes, ovIObjects, ovComponents, Model;

{$R *.dfm}

const
  Queries: array [0..4] of String =
  ('SELECT [*] FROM [] ORDER BY []',
   'SELECT [*] FROM []',
   'SELECT [], [.] FROM []',
   'SELECT [.], Count([..])'#13+
   'FROM [] GROUP BY [.] ORDER BY [.]',
   'SELECT [], [.*] FROM [] WHERE [.] = '''''
  );

procedure TfrmMain.ContactExposerCalcFields(DataSet: TDataSet);
begin
  ContactExposerPhones.Value := (ContactExposer.CurrentObject as IContact).Phones
end;

procedure TfrmMain.PersonExposerAfterPost(DataSet: TDataSet);
var
  CompanyClass: IovClass;
  Company: IovObject;
  CompanyId: TOID;
begin
  CompanyClass := ObjectSpace.Classes[''];

  if CompanyClass.Objects.Find('[.OID#] = ' +
    IntToStr(PersonExposer.CurrentObjectId), Company)
  then Company[''].Remove(PersonExposer.CurrentObject);

  if Not PersonExposerCompany.IsNull then
  begin
    CompanyId := PersonExposerWorksIn.AsInteger;
    Company := CompanyClass.GetObject(CompanyId);
    Company[''].Add(PersonExposer.CurrentObject);
  end;
end;

procedure TfrmMain.GridEnter(Sender: TObject);
begin
  DBNavigator.DataSource := (Sender as TDBGrid).DataSource
end;

procedure TfrmMain.cbQueryChange(Sender: TObject);
begin
  mmQuery.Lines.Text := Queries[cbQuery.ItemIndex]
end;

procedure TfrmMain.QueryBtnClick(Sender: TObject);
begin
  Query.Query := mmQuery.Lines;
  Query.Open;
end;

procedure TfrmMain.ContactsRefresh(DataSet: TDataSet);
begin
  ContactExposer.Refresh;
end;

end.
