unit Model;

interface

uses
  SysUtils, Classes, DB, Forms, DBTables, ovComponents, ovIObjects,
  ovModelStorage, ovConnection;

type
  TdmModel = class(TDataModule)
    ovModel: TovModel;
    ovModelStorage: TovModelStorage;
    ovDatabaseConnection: TovDatabaseConnection;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dmModel: TdmModel;

type
  IContact = interface(IovObject)
  ['{0C6A7B62-2687-45E2-BBAB-15644C82ADDE}']
    function Phones: String;
  end;

var
  ObjectSpace: IovDatabase;

implementation

uses ovObjects, ovConnectionManager;

{$R *.dfm}

type
  TContact = class(TovObject, IContact)
  private
    function Phones: String;
  end;

function TContact.Phones: String;
var
  I: Integer;
begin
  Result := '';
  with Self[''].AsObjects do
  for I := 0 to Count - 1 do
    Result := Result + ', ' + Objects[I][''].AsString;
  System.Delete(Result, 1, 2);
end;

{ TdmModel }

procedure TdmModel.DataModuleCreate(Sender: TObject);
begin
  ObjectSpace := ovModel.Database;
  ovModel.RegisterClass('', TContact);

  ovDatabaseConnection.ConnectionFileName :=
    ExtractFilePath(Application.ExeName) + 'Connections.ovc';
  ovDatabaseConnection.Open;
end;

end.
