unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ovVirtualDataSet, ovDataSet, StdCtrls, Grids, DBGrids,
  ExtCtrls, DBCtrls, ComCtrls, Mask, Menus, XMLIntf,
  ovIObjects, ovDataLinks, ovComponents, ovDataObjects, ovXMLImportExport;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    DBNavigator: TDBNavigator;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    ContactGrid: TDBGrid;
    TabSheet2: TTabSheet;
    CompanyGrid: TDBGrid;
    Splitter1: TSplitter;
    TabSheet3: TTabSheet;
    PersonGrid: TDBGrid;
    TabSheet4: TTabSheet;
    PageControl1: TPageControl;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    CompanyPhoneGrid: TDBGrid;
    TabSheet8: TTabSheet;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    Label5: TLabel;
    Label6: TLabel;
    DBEdit7: TDBEdit;
    Label7: TLabel;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    EmployeeGrid: TDBGrid;
    PageControl2: TPageControl;
    TabSheet9: TTabSheet;
    Splitter2: TSplitter;
    PersonPhoneGrid: TDBGrid;
    QueryGrid: TDBGrid;
    mmQuery: TMemo;
    Panel2: TPanel;
    Splitter3: TSplitter;
    cbQuery: TComboBox;
    QueryBtn: TButton;
    Label9: TLabel;
    QuerySource: TDataSource;
    Query: TovQuery;
    TabSheet10: TTabSheet;
    DBEdit9: TDBEdit;
    DBEdit10: TDBEdit;
    DBEdit11: TDBEdit;
    DBEdit12: TDBEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    MainMenu: TMainMenu;
    N1: TMenuItem;
    ConnectionManagerCmd: TMenuItem;
    DataObjects: TovDataObjects;
    DataLinks: TovDataLinks;
    ExportDataCmd: TMenuItem;
    ImportDataCmd: TMenuItem;
    N2: TMenuItem;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    XMLImport: TovXMLImport;
    XMLExport: TovDataObjectsXMLExport;
    N3: TMenuItem;
    ShowReportCmd: TMenuItem;
    procedure GridEnter(Sender: TObject);
    procedure QueryBtnClick(Sender: TObject);
    procedure cbQueryChange(Sender: TObject);
    procedure ConnectionManagerCmdClick(Sender: TObject);
    procedure DataObjectsCustomCalcFields(Sender: TovCustomDataObjects;
      ADataObjectName: String; DataSet: TovDataSet);
    procedure DataObjectsCreateDataSet(Sender: TovCustomDataObjects;
      ADataObjectName: String; DataSet: TovDataSet);
    procedure DataObjectsAfterPost(Sender: TovCustomDataObjects;
      ADataObjectName: String; DataSet: TovDataSet);
    procedure ExportDataCmdClick(Sender: TObject);
    procedure ImportDataCmdClick(Sender: TObject);
    procedure ShowReportCmdClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ImportData(FileName: String);
    procedure ExportData(FileName: String);
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses ShellAPI, ovTypes, ovDBControlLinks, Model, Reports;

{$R *.dfm}

const
  Queries: array [0..4] of String =
  ('SELECT [*] FROM [] ORDER BY []',
   'SELECT [*] FROM []',
   'SELECT [], [.] FROM []',
   'SELECT [.], Count([..])'#13+
   'FROM [] GROUP BY [.] ORDER BY [.]',
   'SELECT [], [.*] FROM [] WHERE [.] = '''''
  );

procedure TfrmMain.DataObjectsCreateDataSet(Sender: TovCustomDataObjects;
  ADataObjectName: String; DataSet: TovDataSet);
begin
  if ADataObjectName = '' then
    DataSet.AddCustomCalcField('', ftString, 200)
  else
  if ADataObjectName = '' then
    DataSet.AddCustomLookupField('', ftString, 200, ' ',
      'Id', '', DataObjects[''])
end;

procedure TfrmMain.DataObjectsCustomCalcFields(
  Sender: TovCustomDataObjects; ADataObjectName: String;
  DataSet: TovDataSet);
begin
  if ADataObjectName = '' then
    DataSet.FieldByName('').Value := (DataSet.CurrentObject as IContact).Phones
end;

procedure TfrmMain.DataObjectsAfterPost(Sender: TovCustomDataObjects;
  ADataObjectName: String; DataSet: TovDataSet);
var
  CompanyClass: IovClass;
  Company: IovObject;
  CompanyId: TOID;
begin
  if ADataObjectName = '' then
  begin
    CompanyClass := ObjectSpace.Classes[''];

    if CompanyClass.Objects.Find('[.OID#] = ' +
      IntToStr(DataSet.CurrentObjectId), Company)
    then Company[''].Remove(DataSet.CurrentObject);

    if Not DataSet.FieldByName(' ').IsNull then
    begin
      CompanyId := DataSet.FieldByName(' ').AsInteger;
      Company := CompanyClass.GetObject(CompanyId);
      Company[''].Add(DataSet.CurrentObject);
    end;
  end
end;

procedure TfrmMain.GridEnter(Sender: TObject);
begin
  DBNavigator.DataSource := (Sender as TDBGrid).DataSource
end;

procedure TfrmMain.cbQueryChange(Sender: TObject);
begin
  mmQuery.Lines.Text := Queries[cbQuery.ItemIndex]
end;

procedure TfrmMain.QueryBtnClick(Sender: TObject);
begin
  Query.Query := mmQuery.Lines;
  Query.Open;
end;

procedure TfrmMain.ConnectionManagerCmdClick(Sender: TObject);
begin
  dmModel.ovDatabaseConnection.ShowConnectionManager
end;

procedure TfrmMain.ExportDataCmdClick(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    ExportData(SaveDialog.FileName);
    //  ,     .xml      
    ShellExecute(Application.Handle, nil, PChar(SaveDialog.FileName), nil, nil, SW_SHOW);
  end
end;

procedure TfrmMain.ExportData(FileName: String);
begin
  with XMLExport do
  begin
    DataObjectName := '';
    Execute;

    DataObjectName := '';
    Execute;

    SaveToFile(FileName);
  end;
end;

procedure TfrmMain.ImportDataCmdClick(Sender: TObject);
begin
  if OpenDialog.Execute then begin
    ImportData(OpenDialog.FileName);
    DataObjects.Refresh;
  end;
end;

procedure TfrmMain.ImportData(FileName: String);
begin
  XMLImport.InputFileName := FileName;
  XMLImport.Execute;
end;

procedure TfrmMain.ShowReportCmdClick(Sender: TObject);
begin
  with TdmReports.Create(Application) do
  try
    Report.ShowReport;
  finally
    Free
  end;
end;

end.
