unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ovVirtualDataSet, ovDataSet, StdCtrls, Grids, DBGrids,
  ExtCtrls, DBCtrls, ComCtrls, Mask, Menus, XMLIntf,
  ovIObjects, ovDataLinks, ovComponents, ovDataObjects, ovXMLImportExport,
  cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, cxDBData, cxGridCardView, cxGridDBCardView,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, cxControls,
  cxGridCustomView, cxClasses, cxGridLevel, cxGrid;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    DBNavigator: TDBNavigator;
    PageControl: TPageControl;
    TabSheet4: TTabSheet;
    QueryGrid: TDBGrid;
    mmQuery: TMemo;
    Panel2: TPanel;
    Splitter3: TSplitter;
    cbQuery: TComboBox;
    QueryBtn: TButton;
    Label9: TLabel;
    QuerySource: TDataSource;
    Query: TovQuery;
    MainMenu: TMainMenu;
    N1: TMenuItem;
    ConnectionManagerCmd: TMenuItem;
    DataObjects: TovDataObjects;
    DataLinks: TovDataLinks;
    ExportDataCmd: TMenuItem;
    ImportDataCmd: TMenuItem;
    N2: TMenuItem;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    XMLImport: TovXMLImport;
    XMLExport: TovDataObjectsXMLExport;
    TabSheet1: TTabSheet;
    Grid: TcxGrid;
    cxGridLevel1: TcxGridLevel;
    cxGridDBTableView1: TcxGridDBTableView;
    cxGridDBColumn1: TcxGridDBColumn;
    cxGridLevel2: TcxGridLevel;
    cxGridDBTableView2: TcxGridDBTableView;
    cxGridDBColumn2: TcxGridDBColumn;
    cxGridDBColumn3: TcxGridDBColumn;
    cxGridDBColumn4: TcxGridDBColumn;
    cxGridDBColumn5: TcxGridDBColumn;
    cxGridDBColumn6: TcxGridDBColumn;
    cxGridDBColumn7: TcxGridDBColumn;
    cxGridDBColumn8: TcxGridDBColumn;
    cxGridDBColumn9: TcxGridDBColumn;
    cxGridDBColumn10: TcxGridDBColumn;
    cxGridLevel3: TcxGridLevel;
    cxGridDBCardView1: TcxGridDBCardView;
    cxGridDBCardViewRow1: TcxGridDBCardViewRow;
    cxGridDBCardViewRow2: TcxGridDBCardViewRow;
    cxGridLevel4: TcxGridLevel;
    cxGridDBCardView2: TcxGridDBCardView;
    cxGridDBCardViewRow3: TcxGridDBCardViewRow;
    cxGridDBCardViewRow4: TcxGridDBCardViewRow;
    cxGridLevel5: TcxGridLevel;
    cxGridDBTableView3: TcxGridDBTableView;
    cxGridDBColumn11: TcxGridDBColumn;
    cxGridDBColumn12: TcxGridDBColumn;
    cxGridDBColumn13: TcxGridDBColumn;
    cxGridDBColumn14: TcxGridDBColumn;
    cxGridDBColumn15: TcxGridDBColumn;
    cxGridDBColumn16: TcxGridDBColumn;
    cxGridLevel6: TcxGridLevel;
    cxGridDBCardView3: TcxGridDBCardView;
    cxGridDBCardViewRow5: TcxGridDBCardViewRow;
    cxGridDBCardViewRow6: TcxGridDBCardViewRow;
    procedure GridEnter(Sender: TObject);
    procedure QueryBtnClick(Sender: TObject);
    procedure cbQueryChange(Sender: TObject);
    procedure ConnectionManagerCmdClick(Sender: TObject);
    procedure DataObjectsCustomCalcFields(Sender: TovCustomDataObjects;
      ADataObjectName: String; DataSet: TovDataSet);
    procedure DataObjectsCreateDataSet(Sender: TovCustomDataObjects;
      ADataObjectName: String; DataSet: TovDataSet);
    procedure DataObjectsAfterPost(Sender: TovCustomDataObjects;
      ADataObjectName: String; DataSet: TovDataSet);
    procedure ExportDataCmdClick(Sender: TObject);
    procedure ImportDataCmdClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ImportData(FileName: String);
    procedure ExportData(FileName: String);
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses ShellAPI, ovTypes, ovCxGridLinks, Model;

{$R *.dfm}

const
  Queries: array [0..4] of String =
  ('SELECT [*] FROM [] ORDER BY []',
   'SELECT [*] FROM []',
   'SELECT [], [.] FROM []',
   'SELECT [.], Count([..])'#13+
   'FROM [] GROUP BY [.] ORDER BY [.]',
   'SELECT [], [.*] FROM [] WHERE [.] = '''''
  );

procedure TfrmMain.DataObjectsCreateDataSet(Sender: TovCustomDataObjects;
  ADataObjectName: String; DataSet: TovDataSet);
begin
  if ADataObjectName = '' then
    DataSet.AddCustomCalcField('', ftString, 200)
  else
  if ADataObjectName = '' then
    DataSet.AddCustomLookupField('', ftString, 200, ' ',
      'Id', '', DataObjects[''])
end;

procedure TfrmMain.DataObjectsCustomCalcFields(
  Sender: TovCustomDataObjects; ADataObjectName: String;
  DataSet: TovDataSet);
begin
  if ADataObjectName = '' then
    DataSet.FieldByName('').Value := (DataSet.CurrentObject as IContact).Phones
end;

procedure TfrmMain.DataObjectsAfterPost(Sender: TovCustomDataObjects;
  ADataObjectName: String; DataSet: TovDataSet);
var
  CompanyClass: IovClass;
  Company: IovObject;
  CompanyId: TOID;
begin
  if ADataObjectName = '' then
  begin
    CompanyClass := ObjectSpace.Classes[''];

    if CompanyClass.Objects.Find('[.OID#] = ' +
      IntToStr(DataSet.CurrentObjectId), Company)
    then Company[''].Remove(DataSet.CurrentObject);

    if Not DataSet.FieldByName(' ').IsNull then
    begin
      CompanyId := DataSet.FieldByName(' ').AsInteger;
      Company := CompanyClass.GetObject(CompanyId);
      Company[''].Add(DataSet.CurrentObject);
    end;
  end
end;

procedure TfrmMain.GridEnter(Sender: TObject);
begin
  DBNavigator.DataSource := (Sender as TDBGrid).DataSource
end;

procedure TfrmMain.cbQueryChange(Sender: TObject);
begin
  mmQuery.Lines.Text := Queries[cbQuery.ItemIndex]
end;

procedure TfrmMain.QueryBtnClick(Sender: TObject);
begin
  Query.Query := mmQuery.Lines;
  Query.Open;
end;

procedure TfrmMain.ConnectionManagerCmdClick(Sender: TObject);
begin
  dmModel.ovDatabaseConnection.ShowConnectionManager
end;

procedure TfrmMain.ExportDataCmdClick(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    ExportData(SaveDialog.FileName);
    //  ,     .xml      
    ShellExecute(Application.Handle, nil, PChar(SaveDialog.FileName), nil, nil, SW_SHOW);
  end
end;

procedure TfrmMain.ExportData(FileName: String);
begin
  with XMLExport do
  begin
    DataObjectName := '';
    Execute;

    DataObjectName := '';
    Execute;

    SaveToFile(FileName);
  end;
end;

procedure TfrmMain.ImportDataCmdClick(Sender: TObject);
begin
  if OpenDialog.Execute then begin
    ImportData(OpenDialog.FileName);
    DataObjects.Refresh;
  end;
end;

procedure TfrmMain.ImportData(FileName: String);
begin
  XMLImport.InputFileName := FileName;
  XMLImport.Execute;
end;

end.
